OpenVDB: ValueAccessor3< _TreeType, IsSafe, L0, L1, L2 > Class Template Reference

OpenVDB 6.0.0

Public Types | Public Member Functions | Static Public Member Functions | Static Public Attributes | Protected Attributes | Friends | List of all members
ValueAccessor3< _TreeType, IsSafe, L0, L1, L2 > Class Template Reference

Value accessor with three levels of node caching. More...

`#include <ValueAccessor.h>`

Inherits ValueAccessorBase< _TreeType, IsSafe >.

## Public Types
using | TreeType = _TreeType
using | ValueType = typename TreeType::ValueType
using | RootNodeT = typename TreeType::RootNodeType
using | LeafNodeT = typename TreeType::LeafNodeType
using | BaseT = ValueAccessorBase< TreeType, IsSafe >
using | InvTreeT = typename RootNodeT::NodeChainType
using | NodeT0 = typename boost::mpl::at< InvTreeT, boost::mpl::int_< L0 > >::type
using | NodeT1 = typename boost::mpl::at< InvTreeT, boost::mpl::int_< L1 > >::type
using | NodeT2 = typename boost::mpl::at< InvTreeT, boost::mpl::int_< L2 > >::type

## Public Member Functions
| ValueAccessor3 (TreeType &tree)
| Constructor from a tree. More...
| ValueAccessor3 (const ValueAccessor3 &other)
| Copy constructor. More...
ValueAccessor3 & | operator= (const ValueAccessor3 &other)
| Asignment operator. More...
| ~ValueAccessor3 () override=default
| Virtual destructor. More...
bool | isCached (const Coord &xyz) const
const ValueType & | getValue (const Coord &xyz) const
| Return the value of the voxel at the given coordinates. More...
bool | isValueOn (const Coord &xyz) const
| Return the active state of the voxel at the given coordinates. More...
bool | probeValue (const Coord &xyz, ValueType &value) const
| Return the active state of the voxel as well as its value. More...
int | getValueDepth (const Coord &xyz) const
bool | isVoxel (const Coord &xyz) const
void | setValueOnly (const Coord &xyz, const ValueType &value)
| Set the value of the voxel at the given coordinate but preserves its active state. More...
void | setValueOff (const Coord &xyz, const ValueType &value)
| Set the value of the voxel at the given coordinates and mark the voxel as inactive. More...
template<typename ModifyOp >
void | modifyValue (const Coord &xyz, const ModifyOp &op)
| Apply a functor to the value of the voxel at the given coordinates and mark the voxel as active. More...
template<typename ModifyOp >
void | modifyValueAndActiveState (const Coord &xyz, const ModifyOp &op)
| Apply a functor to the voxel at the given coordinates. More...
void | setActiveState (const Coord &xyz, bool on=true)
| Set the active state of the voxel at the given coordinates without changing its value. More...
void | setValueOn (const Coord &xyz)
| Mark the voxel at the given coordinates as active without changing its value. More...
void | setValueOff (const Coord &xyz)
| Mark the voxel at the given coordinates as inactive without changing its value. More...
template<typename NodeT >
NodeT * | getNode ()
| Return the cached node of type NodeType. [Mainly for internal use]. More...
template<typename NodeT >
void | insertNode (const Coord &xyz, NodeT &node)
template<typename NodeT >
void | eraseNode ()
void | addLeaf (LeafNodeT *leaf)
| Add the specified leaf to this tree, possibly creating a child branch in the process. If the leaf node already exists, replace it. More...
void | addTile (Index level, const Coord &xyz, const ValueType &value, bool state)
| Add a tile at the specified tree level that contains voxel (x, y, z), possibly deleting existing nodes or creating new nodes in the process. More...
LeafNodeT * | touchLeaf (const Coord &xyz)
template<typename NodeT >
NodeT * | probeNode (const Coord &xyz)
LeafNodeT * | probeLeaf (const Coord &xyz)
template<typename NodeT >
const NodeT * | probeConstNode (const Coord &xyz) const
const LeafNodeT * | probeConstLeaf (const Coord &xyz) const
const LeafNodeT * | probeLeaf (const Coord &xyz) const
void | clear () override
| Remove all the cached nodes and invalidate the corresponding hash-keys. More...
_TreeType * | getTree () const
| Return a pointer to the tree associated with this accessor. More...
_TreeType & | tree () const
| Return a reference to the tree associated with this accessor. More...
void | setValue (const Coord &xyz, const ValueType &value)
| Set the value of the voxel at the given coordinates and mark the voxel as active. More...
void | setValueOn (const Coord &xyz, const ValueType &value)
| Set the value of the voxel at the given coordinates and mark the voxel as active. More...

## Static Public Member Functions
static Index | numCacheLevels ()
| Return the number of cache levels employed by this ValueAccessor. More...
static bool | isSafe ()
| Return true if this accessor is safe, i.e. registered by the tree from which it is constructed. Un-registered accessors can in rare cases be faster because it avoids the (small) overhead of registration, but they are unsafe if the tree is modified. So unless you're an expert it is highly recommended to set IsSafe = true (which is the default). More...

## Static Public Attributes
static const bool | IsConstTree

## Protected Attributes
_TreeType * | mTree

## Friends
template<typename >
class | RootNode
template<typename , Index >
class | InternalNode
template<typename , Index >
class | LeafNode
template<typename >
class | Tree

## Detailed Description

### template<typename _TreeType, bool IsSafe, Index L0, Index L1, Index L2>
class openvdb::v6_0::tree::ValueAccessor3< _TreeType, IsSafe, L0, L1, L2 >

Value accessor with three levels of node caching.

The node cache levels are specified by L0, L1, and L2 with the default values 0, 1 and 2 (defined in the forward declaration) corresponding to a LeafNode, its parent InternalNode, and its parent InternalNode. Since the default configuration of all typed trees and grids, e.g., FloatTree or FloatGrid, has a depth of four, this value accessor is the one used by default.

Note
  This class is for experts only and should rarely be used directly. Instead use ValueAccessor with its default template arguments

## Member Typedef Documentation

## ◆ BaseT

using BaseT = ValueAccessorBase<TreeType, IsSafe>

## ◆ InvTreeT

using InvTreeT = typename RootNodeT::NodeChainType

## ◆ LeafNodeT

using LeafNodeT = typename TreeType::LeafNodeType

## ◆ NodeT0

using NodeT0 = typename boost::mpl::at<InvTreeT, boost::mpl::int_<L0> >::type

## ◆ NodeT1

using NodeT1 = typename boost::mpl::at<InvTreeT, boost::mpl::int_<L1> >::type

## ◆ NodeT2

using NodeT2 = typename boost::mpl::at<InvTreeT, boost::mpl::int_<L2> >::type

## ◆ RootNodeT

using RootNodeT = typename TreeType::RootNodeType

## ◆ TreeType

using TreeType = _TreeType

## ◆ ValueType

using ValueType = typename TreeType::ValueType

## Constructor & Destructor Documentation

## ◆ ValueAccessor3() [1/2]

ValueAccessor3 | ( | TreeType & | tree | ) |
| inline

Constructor from a tree.

## ◆ ValueAccessor3() [2/2]

ValueAccessor3 | ( | const ValueAccessor3< _TreeType, IsSafe, L0, L1, L2 > & | other | ) |
| inline

Copy constructor.

## ◆ ~ValueAccessor3()

~ValueAccessor3 | ( |  | ) |
| overridedefault

Virtual destructor.

## Member Function Documentation

## ◆ addLeaf()

void addLeaf | ( | LeafNodeT * | leaf | ) |
| inline

Add the specified leaf to this tree, possibly creating a child branch in the process. If the leaf node already exists, replace it.

## ◆ addTile()

void addTile | ( | Index | level,
|  | const Coord & | xyz,
|  | const ValueType & | value,
|  | bool | state
| ) |  |
| inline

Add a tile at the specified tree level that contains voxel (x, y, z), possibly deleting existing nodes or creating new nodes in the process.

## ◆ clear()

void clear | ( |  | ) |
| inlineoverridevirtual

Remove all the cached nodes and invalidate the corresponding hash-keys.

Implements ValueAccessorBase< _TreeType, IsSafe >.

## ◆ eraseNode()

void eraseNode | ( |  | ) |
| inline

If a node of the given type exists in the cache, remove it, so that isCached(xyz) returns `false` for any voxel (x, y, z) contained in that node. [Mainly for internal use]

## ◆ getNode()

NodeT* getNode | ( |  | ) |
| inline

Return the cached node of type NodeType. [Mainly for internal use].

## ◆ getTree()

_TreeType * getTree | ( |  | ) | const
| inlineinherited

Return a pointer to the tree associated with this accessor.

The pointer will be null only if the tree from which this accessor was constructed was subsequently deleted (which generally leaves the accessor in an unsafe state).

## ◆ getValue()

const ValueType& getValue | ( | const Coord & | xyz | ) | const
| inline

Return the value of the voxel at the given coordinates.

## ◆ getValueDepth()

int getValueDepth | ( | const Coord & | xyz | ) | const
| inline

Return the tree depth (0 = root) at which the value of voxel (x, y, z) resides, or -1 if (x, y, z) isn't explicitly represented in the tree (i.e., if it is implicitly a background voxel).

## ◆ insertNode()

void insertNode | ( | const Coord & | xyz,
|  | NodeT & | node
| ) |  |
| inline

Cache the given node, which should lie along the path from the root node to the node containing voxel (x, y, z). [Mainly for internal use]

## ◆ isCached()

bool isCached | ( | const Coord & | xyz | ) | const
| inline

Return `true` if any of the nodes along the path to the given voxel have been cached.

## ◆ isSafe()

static bool isSafe | ( |  | ) |
| inlinestaticinherited

Return true if this accessor is safe, i.e. registered by the tree from which it is constructed. Un-registered accessors can in rare cases be faster because it avoids the (small) overhead of registration, but they are unsafe if the tree is modified. So unless you're an expert it is highly recommended to set IsSafe = true (which is the default).

## ◆ isValueOn()

bool isValueOn | ( | const Coord & | xyz | ) | const
| inline

Return the active state of the voxel at the given coordinates.

## ◆ isVoxel()

bool isVoxel | ( | const Coord & | xyz | ) | const
| inline

Return `true` if the value of voxel (x, y, z) resides at the leaf level of the tree, i.e., if it is not a tile value.

## ◆ modifyValue()

void modifyValue | ( | const Coord & | xyz,
|  | const ModifyOp & | op
| ) |  |
| inline

Apply a functor to the value of the voxel at the given coordinates and mark the voxel as active.

See Tree::modifyValue() for details.

## ◆ modifyValueAndActiveState()

void modifyValueAndActiveState | ( | const Coord & | xyz,
|  | const ModifyOp & | op
| ) |  |
| inline

Apply a functor to the voxel at the given coordinates.

See Tree::modifyValueAndActiveState() for details.

## ◆ numCacheLevels()

static Index numCacheLevels | ( |  | ) |
| inlinestatic

Return the number of cache levels employed by this ValueAccessor.

## ◆ operator=()

ValueAccessor3& operator= | ( | const ValueAccessor3< _TreeType, IsSafe, L0, L1, L2 > & | other | ) |
| inline

Asignment operator.

## ◆ probeConstLeaf()

const LeafNodeT* probeConstLeaf | ( | const Coord & | xyz | ) | const
| inline

Returns
  a const pointer to the leaf node that contains voxel (x, y, z) and if it doesn't exist, return `nullptr`.

## ◆ probeConstNode()

const NodeT* probeConstNode | ( | const Coord & | xyz | ) | const
| inline

Returns
  a const pointer to the node of the specified type that contains voxel (x, y, z) and if it doesn't exist, return `nullptr`.

## ◆ probeLeaf() [1/2]

LeafNodeT* probeLeaf | ( | const Coord & | xyz | ) |
| inline

Returns
  a pointer to the leaf node that contains voxel (x, y, z) and if it doesn't exist, return `nullptr`.

## ◆ probeLeaf() [2/2]

const LeafNodeT* probeLeaf | ( | const Coord & | xyz | ) | const
| inline

## ◆ probeNode()

NodeT* probeNode | ( | const Coord & | xyz | ) |
| inline

Returns
  a pointer to the node of the specified type that contains voxel (x, y, z) and if it doesn't exist, return `nullptr`.

## ◆ probeValue()

bool probeValue | ( | const Coord & | xyz,
|  | ValueType & | value
| ) |  | const
| inline

Return the active state of the voxel as well as its value.

## ◆ setActiveState()

void setActiveState | ( | const Coord & | xyz,
|  | bool | on = `true`
| ) |  |
| inline

Set the active state of the voxel at the given coordinates without changing its value.

## ◆ setValue()

void setValue | ( | const Coord & | xyz,
|  | const ValueType & | value
| ) |  |
| inline

Set the value of the voxel at the given coordinates and mark the voxel as active.

## ◆ setValueOff() [1/2]

void setValueOff | ( | const Coord & | xyz,
|  | const ValueType & | value
| ) |  |
| inline

Set the value of the voxel at the given coordinates and mark the voxel as inactive.

## ◆ setValueOff() [2/2]

void setValueOff | ( | const Coord & | xyz | ) |
| inline

Mark the voxel at the given coordinates as inactive without changing its value.

## ◆ setValueOn() [1/2]

void setValueOn | ( | const Coord & | xyz,
|  | const ValueType & | value
| ) |  |
| inline

Set the value of the voxel at the given coordinates and mark the voxel as active.

## ◆ setValueOn() [2/2]

void setValueOn | ( | const Coord & | xyz | ) |
| inline

Mark the voxel at the given coordinates as active without changing its value.

## ◆ setValueOnly()

void setValueOnly | ( | const Coord & | xyz,
|  | const ValueType & | value
| ) |  |
| inline

Set the value of the voxel at the given coordinate but preserves its active state.

## ◆ touchLeaf()

LeafNodeT* touchLeaf | ( | const Coord & | xyz | ) |
| inline

Returns
  the leaf node that contains voxel (x, y, z) and if it doesn't exist, create it, but preserve the values and active states of all voxels.

Use this method to preallocate a static tree topology over which to safely perform multithreaded processing.

## ◆ tree()

_TreeType & tree | ( |  | ) | const
| inlineinherited

Return a reference to the tree associated with this accessor.

## Friends And Related Function Documentation

## ◆ InternalNode

friend class InternalNode
| friend

## ◆ LeafNode

friend class LeafNode
| friend

## ◆ RootNode

friend class RootNode
| friend

## ◆ Tree

friend class Tree
| friend

## Member Data Documentation

## ◆ IsConstTree

const bool IsConstTree
| staticinherited

## ◆ mTree

_TreeType * mTree
| protectedinherited

The documentation for this class was generated from the following file:

- ValueAccessor.h